#!/util/bin/perl

# Given a domain, we now display all the interesting information we can
# about it.  Maybe we'll get spiffy about it later, but for now we're going
# to do this in a fairly plain manner.

use CGI;
use Bind;

sub zonesort {
    my(@a) = split(/\./,$a);
    my(@b) = split(/\./,$b);

    while (@a) {
	$aval = pop @a;
	$bval = pop @b;
	if ($aval =~ /^\d+$/ && $bval =~ /^\d+$/) {
	    if ($foo = $aval <=> $bval) {
		return $foo;
	    }
	} else {
	    if ($foo = $aval cmp $bval) {
		return $foo;
	    }
	}
    }
    return 0;
}

$doc = new CGI;

print $doc->header;
print $doc->start_html('Zone Contents');

if (!$doc->param('zone')) {
    print "No zone has been selected yet.\n";
}

$dns = new Bind('/local/stock/Bind/domain/named.boot');

if (!defined($dns)) {
    print "The zone is being locked.  Please try again.\n";
    exit 0;
}

$zone = $doc->param('zone');
foreach $host (sort zonesort $dns->listzone($doc->param('zone'))) {
    print $doc->a({href=>"edithost.cgi?host=$host&zone=$zone",target=>'edit'},
		  $host),"<br>\n";
}
